"use strict";

var log = "", classLog = "",
	csm = new CalcStateMach();

var input = function(button) {
	log += button;
	csm.push(button);
	display(csm.screen);
};

input("C");

// Mouse Input
var buttons = $("button")
	.on("click", function () {
		var cs		= "0123456789dCEetsmp",
			keys	= "0123456789.CE=*/-+";
		input(keys[cs.indexOf(this.className.substr(-1))]);
		classLog += this.className.substr(-1);
	});

// Key Inputs
$(window).on("keypress", function (k) {
	var keyPressed = String.fromCharCode(k.keyCode),
		keys	= "0123456789.ce=*/-+",
		cs		= "0123456789dCEetsmp",
		c;
	if (k.keyCode === 13) { keyPressed = "="; } // Enter key
	if ((c = keys.indexOf(keyPressed)) >= 0) {
		classLog += cs.charAt(c);
		$(".button-" + cs.charAt(c))
		.trigger("click")
		.addClass("depressed");
	}
});
$(window).on("keyup", function (k) {
	$(".depressed").removeClass("depressed");
});

function display (num) { // num as string!
	var nA = num.split(""),
	$display = $("#display"),
	chars = "0123456789.-E".split(""),
	classes = [	"zero", "one", "two", "three", "four", "five", "six", "seven", "eight",
				"nine", "point", "minus", "error" ];

	$display.children().remove();	
	for (var i = 0, l = nA.length; i < l; ++i) {
		$("<span class='number'></span>")
		.appendTo( $display )
		.addClass( classes[ chars.indexOf(nA[i]) ] );
	}
}
